//
//  AIStateCounter.m
//  MonsterWars
//
//  Created by Ray Wenderlich on 10/25/12.
//  Copyright (c) 2012 Razeware LLC. All rights reserved.
//

#import "AIStateCounter.h"
#import "AIPlayer.h"
#import "HelloWorldLayer.h"
#import "AIStateMass.h"
#import "AIStateDefend.h"

@implementation AIStateCounter

- (NSString *)name {
    return @"Counter";
}

- (void)execute:(AIPlayer *)player {
    
    // Check if should change state
    NSArray * enemies = [player.layer enemiesWithinRange:200 ofPlayer:player];
    if (enemies.count > 0) {
        
        while (player.coins > COST_QUIRK) {            
            if (player.layer.aiQuirkValue < player.layer.humanZapValue && player.coins > COST_QUIRK) {
                [player.layer spawnQuirkForPlayer:player];
            } else if (player.layer.aiZapValue < player.layer.humanMunchValue && player.coins > COST_ZAP) {
                [player.layer spawnZapForPlayer:player];
            } else if (player.layer.aiMunchValue < player.layer.humanQuirkValue && player.coins > COST_MUNCH) {
                [player.layer spawnMunchForPlayer:player];
            } else {
                [player.layer spawnQuirkForPlayer:player];
            }
        }
        
        [player changeState:[[AIStateDefend alloc] init]];
        return;
    }
    
}

@end
