//
//  AIStateDefend.m
//  MonsterWars
//
//  Created by Ray Wenderlich on 10/25/12.
//  Copyright (c) 2012 Razeware LLC. All rights reserved.
//

#import "AIStateDefend.h"
#import "AIPlayer.h"
#import "HelloWorldLayer.h"
#import "AIStateCounter.h"
#import "AIStateMass.h"
#import "SimpleAudioEngine.h"
#import "AIStateRush.h"

@implementation AIStateDefend

- (NSString *)name {
    return @"Defend";
}

- (void)enter:(AIPlayer *)player {
    [[SimpleAudioEngine sharedEngine] playEffect:@"defend.wav"];
}

- (void)execute:(AIPlayer *)player {

    // Check if should change state
    NSArray * enemies = [player.layer enemiesWithinRange:200 ofPlayer:player];
    if (enemies.count == 0) {
        [player changeState:[[AIStateRush alloc] init]];
        return;
    }
    
    [player.layer setPlayer:player attacking:NO];
    
    // Make build decision
    if (player.layer.aiTotalValue == 0 || player.layer.humanTotalValue > player.layer.aiTotalValue * 2) {
        if (player.layer.aiQuirkValue < player.layer.humanZapValue && player.coins > COST_QUIRK) {
            [player.layer spawnQuirkForPlayer:player];
        } else if (player.layer.aiZapValue < player.layer.humanMunchValue && player.coins > COST_ZAP) {
            [player.layer spawnZapForPlayer:player];
        } else if (player.layer.aiMunchValue < player.layer.humanQuirkValue && player.coins > COST_MUNCH) {
            [player.layer spawnMunchForPlayer:player];
        } else if (player.layer.humanTotalValue == 0) {
            while (player.coins > COST_ZAP + COST_QUIRK) {
                [player.layer spawnQuirkForPlayer:player];
                [player.layer spawnZapForPlayer:player];
            }
        }
    }
}

@end
