//
//  AIStateMass.m
//  MonsterWars
//
//  Created by Ray Wenderlich on 10/25/12.
//  Copyright (c) 2012 Razeware LLC. All rights reserved.
//

#import "AIStateMass.h"
#import "AIPlayer.h"
#import "HelloWorldLayer.h"
#import "AIStateCounter.h"
#import "AIStateDefend.h"
#import "AIStateRush.h"
#import "SimpleAudioEngine.h"

@implementation AIStateMass

- (NSString *)name {
    return @"Mass";
}

- (void)enter:(AIPlayer *)player {
    [[SimpleAudioEngine sharedEngine] playEffect:@"mass.wav"];
}

- (void)execute:(AIPlayer *)player {

    // Check if should change state
    NSArray * enemies = [player.layer enemiesWithinRange:200 ofPlayer:player];
    if (enemies.count > 0) {
        [player changeState:[[AIStateDefend alloc] init]];
        return;
    } else if (player.layer.aiTotalValue + player.coins >= COST_MUNCH + COST_ZAP*2) {
        //[player.layer spawnMunchForPlayer:player];
        //[player.layer spawnZapForPlayer:player];
        //[player.layer spawnZapForPlayer:player];
        //[player.layer spawnZapForPlayer:player];
        //[player.layer spawnQuirkForPlayer:player];
        //[player.layer spawnQuirkForPlayer:player];
        [player changeState:[[AIStateCounter alloc] init]];
        return;
    }
    
    [player.layer setPlayer:player attacking:NO];
    
}

- (void)exit:(AIPlayer *)player {
    
}

@end
