//
//  AIStateRush.m
//  MonsterWars
//
//  Created by Ray Wenderlich on 10/25/12.
//  Copyright (c) 2012 Razeware LLC. All rights reserved.
//

#import "AIStateRush.h"
#import "AIPlayer.h"
#import "HelloWorldLayer.h"
#import "AIStateCounter.h"
#import "AIStateMass.h"
#import "AIStateDefend.h"
#import "SimpleAudioEngine.h"

@implementation AIStateRush

- (NSString *)name {
    return @"Rush";
}

- (void)enter:(AIPlayer *)player {
    [[SimpleAudioEngine sharedEngine] playEffect:@"attack.wav"];
}

- (void)execute:(AIPlayer *)player {
    // Check if should change state
    NSArray * enemies = [player.layer enemiesWithinRange:200 ofPlayer:player];
    if (enemies.count > 0) {
        [player changeState:[[AIStateDefend alloc] init]];
        return;
    } else if (player.layer.aiTotalValue == 0) {
        [player changeState:[[AIStateMass alloc] init]];
        return;
    }
    
    [player.layer setPlayer:player attacking:YES];
    
    // Make build decision
    if (player.layer.aiTotalValue >= player.layer.humanTotalValue) {
        [player.layer spawnQuirkForPlayer:player];
    }
}

@end
